/*
 * tls.h
 * 
 * This file is part of the msmtp package, a very simple programm that 
 * works as an "SMTP plugin" for Mutt and possibly other MUAs.
 *
 * Copyright (C) 2000, 2003	Martin Lambers <marlam@web.de>
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef TLS_H
#define TLS_H

#include <openssl/ssl.h>

#define TLS_METHOD_NONE		1
#define TLS_METHOD_CHOOSE	2
#define TLS_METHOD_TLS1		3
#define TLS_METHOD_SSL3		4
#define TLS_METHOD_SSL2		5

typedef struct
{
    SSL_CTX *ssl_ctx;
    SSL *ssl;
} tls_t;

void tls_clear(tls_t *tls);
int tls_init(tls_t *tls, int method);
int tls_start(tls_t *tls, int fd);
int tls_is_active(tls_t *tls);
int tls_getchar(tls_t *tls, char *c);
int tls_putline(tls_t *tls, char *line);
void tls_close(tls_t *tls);

#endif
